Unit afb1e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTBF11_p;

procedure afb1e(var A :Array of Extended; N :Integer; NLC :Integer;
                NUC :Integer; var R :Array of Extended;
                var IERR :Integer);

implementation

procedure afb1e(var A :Array of Extended; N :Integer; NLC :Integer;
                NUC :Integer; var R :Array of Extended;
                var IERR :Integer);
var
JBEG,NLC1,NN,JEND,K,J,K1,NC,I,L,IK :Integer;
P,Q,RN :Extended;
const
ZERO :Extended = 0.0e0;
ONE :Extended = 1.0e0;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18;
begin
IERR := 0;
JBEG := NLC+1;
NLC1 := JBEG;
RN := N;
I := 1;
NC := JBEG+NUC;
NN := NC;
JEND := NC;
if ( N = 1 ) or ( NLC = 0 ) 
 then goto _5;
_1:
K := 1;
P := ZERO;
for J:=JBEG to JEND do
 begin
  A[(I-1)+(K-1)*N] := A[(I-1)+(J-1)*N];
  Q := Abs(A[(I-1)+(K-1)*N]);
  if ( Q > P )
   then P := Q;
  K := K+1;
_2:
 end;
if ( P = ZERO ) 
 then goto _17;
R[(I-1)+(NLC1-1)*N] := ONE/P;
if ( K > NC ) 
 then goto _4;
for J:=K to NC do
 begin
  A[(I-1)+(J-1)*N] := ZERO;
_3:
 end;
_4:
I := I+1;
JBEG := JBEG-1;
if ( JEND-JBEG = N )
 then JEND := JEND-1;
if ( I <= NLC ) 
 then goto _1;
JBEG := I;
NN := JEND;
_5:
JEND := N-NUC;
for I:=JBEG to N do
 begin
  P := ZERO;
  for J:=1 to NN do
   begin
    Q := Abs(A[(I-1)+(J-1)*N]);
    if ( Q > P ) 
     then P := Q;
_6:
   end;
  if ( P = ZERO )
   then goto _17;
  R[(I-1)+(NLC1-1)*N] := ONE/P;
  if ( I = JEND ) 
   then goto _8;
  if ( I < JEND ) 
   then goto _9;
  K := NN+1;
  for J:=K to NC do
   begin
    A[(I-1)+(J-1)*N] := ZERO;
_7:
   end;
_8:
  NN := NN-1;
_9:
 end;
L := NLC;
for K:=1 to N do
 begin
  P := Abs(A[(K-1)+0*N])*R[(K-1)+(NLC1-1)*N];
  I := K;
  if ( L < N ) 
   then L := L+1;
  K1 := K+1;
  if ( K1 > L ) 
   then goto _11;
  for J:=K1 to L do
   begin
    Q := Abs(A[(J-1)+0*N])*R[(J-1)+(NLC1-1)*N];
    if ( Q <= P ) 
     then goto _10;
    P := Q;
    I := J;
_10:
   end;
_11:
  R[(I-1)+(NLC1-1)*N] := R[(K-1)+(NLC1-1)*N];
  R[(K-1)+(NLC1-1)*N] := I;
  if ( RN+P = RN ) 
   then goto _17;
  if ( K = I ) 
   then goto _13;
  for J:=1 to NC do
   begin
    P := A[(K-1)+(J-1)*N];
    A[(K-1)+(J-1)*N] := A[(I-1)+(J-1)*N];
    A[(I-1)+(J-1)*N] := P;
_12:
   end;
_13:
  if ( K1 > L ) 
   then goto _16;
  for I:=K1 to L do
   begin
    P := A[(I-1)+0*N]/A[(K-1)+0*N];
    IK := I-K;
    R[(K1-1)+(IK-1)*N] := P;
    for J:=2 to NC do
     begin
      A[(I-1)+(J-2)*N] := A[(I-1)+(J-1)*N]-P*A[(K-1)+(J-1)*N];
_14:
     end;
    A[(I-1)+(NC-1)*N] := ZERO;
_15:
   end;
_16:
 end;
goto _18;
_17:
IERR := 129;
UTBF11(IERR,1);
_18:
end;

end.
